diff --git a/blivet/devicetree.py b/blivet/devicetree.py
index 0770840..9bcadc2 100644
--- a/blivet/devicetree.py
+++ b/blivet/devicetree.py
@@ -59,29 +59,43 @@ log = logging.getLogger("blivet")
 class DeviceTree(object):
     """ A quasi-tree that represents the devices in the system.
 
-        The tree contains a list of device instances, which does not
-        necessarily reflect the actual state of the system's devices.
-        DeviceActions are used to perform modifications to the tree,
-        except when initially populating the tree.
+        The tree contains a list of :class:`~.devices.StorageDevice` instances,
+        which does not necessarily reflect the actual state of the system's
+        devices. :class:`~.deviceaction.DeviceAction` is used to perform
+        modifications to the tree, except when initially populating the tree.
 
-        DeviceAction instances are registered, possibly causing the
-        addition or removal of Device instances to/from the tree. The
-        DeviceActions are all reversible up to the time their execute
-        method has been called.
+        :class:`~.deviceaction.DeviceAction` instances are registered, possibly
+        causing the addition or removal of :class:`~.devices.StorageDevice`
+        instances to/from the tree. A :class:`~.deviceaction.DeviceAction`
+        is reversible up to the time its 'execute' method is called.
 
         Only one action of any given type/object pair should exist for
         any given device at any given time.
 
-        DeviceAction instances can only be registered for leaf devices,
-        except for resize actions.
+        :class:`~.deviceaction.DeviceAction` instances can only be registered
+        for leaf devices, except for resize actions.
     """
 
     def __init__(self, conf=None, passphrase=None, luksDict=None,
                  iscsi=None, dasd=None):
+        """
+
+            :keyword conf: storage discovery configuration
+            :type conf: :class:`~.StorageDiscoveryConfig`
+            :keyword passphrase: default LUKS passphrase
+            :keyword luksDict: a dict with UUID keys and passphrase values
+            :type luksDict: dict
+            :keyword iscsi: ISCSI control object
+            :type iscsi: :class:`~.iscsi.iscsi`
+            :keyword dasd: DASD control object
+            :type dasd: :class:`~.dasd.DASD`
+
+        """
         self.reset(conf, passphrase, luksDict, iscsi, dasd)
 
     def reset(self, conf=None, passphrase=None, luksDict=None,
               iscsi=None, dasd=None):
+        """ Reset the instance to its initial state. """
         # internal data members
         self._devices = []
         self._actions = []
@@ -129,7 +143,17 @@ class DeviceTree(object):
         self._cleanup = False
 
     def setDiskImages(self, images):
-        """ Set the disk images and reflect them in exclusiveDisks. """
+        """ Set the disk images and reflect them in exclusiveDisks.
+
+            :param images: dict with image name keys and filename values
+            :type images: dict
+
+            .. note::
+
+                Disk images are automatically exclusive. That means that, in the
+                presence of disk images, any local storage not associated with
+                the disk images is ignored.
+        """
         self.diskImages = images
         # disk image files are automatically exclusive
         self.exclusiveDisks = self.diskImages.keys()
@@ -259,6 +283,9 @@ class DeviceTree(object):
     def _addDevice(self, newdev):
         """ Add a device to the tree.
 
+            :param newdev: the device to add
+            :type newdev: a subclass of :class:`~.devices.StorageDevice`
+
             Raise ValueError if the device's identifier is already
             in the list.
         """
@@ -286,7 +313,16 @@ class DeviceTree(object):
     def _removeDevice(self, dev, force=None, moddisk=True):
         """ Remove a device from the tree.
 
-            Only leaves may be removed.
+            :param dev: the device to remove
+            :type dev: a subclass of :class:`~.devices.StorageDevice`
+            :keyword force: whether to force removal of a non-leaf device
+            :type force: bool
+            :keyword moddisk: update parent disk's format (partitions only)
+            :type moddisk: bool
+
+            .. note::
+
+                Only leaves may be removed.
         """
         if dev not in self._devices:
             raise ValueError("Device '%s' not in tree" % dev.name)
@@ -336,6 +372,9 @@ class DeviceTree(object):
     def registerAction(self, action):
         """ Register an action to be performed at a later time.
 
+            :param action: the action
+            :type action: :class:`~.deviceaction.DeviceAction`
+
             Modifications to the Device instance are handled before we
             get here.
         """
@@ -361,6 +400,9 @@ class DeviceTree(object):
     def cancelAction(self, action):
         """ Cancel a registered action.
 
+            :param action: the action
+            :type action: :class:`~.deviceaction.DeviceAction`
+
             This will unregister the action and do any required
             modifications to the device list.
 
@@ -383,12 +425,21 @@ class DeviceTree(object):
                     devid=None):
         """ Find all actions that match all specified parameters.
 
-            Keyword arguments:
-
-                device -- device to match (Device, or None to match any)
-                type -- action type to match (string, or None to match any)
-                object -- operand type to match (string, or None to match any)
-                path -- device path to match (string, or None to match any)
+            A value of None for any of the keyword arguments indicates that any
+            value is acceptable for that field.
+
+            :keyword device: device to match
+            :type device: :class:`~.devices.StorageDevice` or None
+            :keyword type: action type to match (eg: "create", "destroy")
+            :type type: str or None
+            :keyword object: operand type to match (eg: "device" or "format")
+            :type object: str or None
+            :keyword path: device path to match
+            :type path: str or None
+            :keyword devid: device id to match
+            :type devid: int or None
+            :returns: a list of matching actions
+            :rtype: list of :class:`~.deviceaction.DeviceAction`
 
         """
         if device is None and type is None and object is None and \
@@ -424,6 +475,9 @@ class DeviceTree(object):
         """ Return a list of devices that depend on dep.
 
             The list includes both direct and indirect dependents.
+
+            :param dep: the device whose dependents we are looking for
+            :type dep: :class:`~.devices.StorageDevice`
         """
         dependents = []
 
@@ -442,14 +496,10 @@ class DeviceTree(object):
     def isIgnored(self, info):
         """ Return True if info is a device we should ignore.
 
-            Arguments:
-
-                info -- a dict representing a udev db entry
-
-            TODO:
-
-                - filtering of SAN/FC devices
-                - filtering by driver?
+            :param info: udevdb device entry
+            :type info: dict
+            :returns: whether the device will be ignored
+            :rtype: bool
 
         """
         sysfs_path = udev_device_get_sysfs_path(info)
@@ -513,12 +563,20 @@ class DeviceTree(object):
         # FIXME: check for virtual devices whose slaves are on the ignore list
 
     def udevDeviceIsDisk(self, info):
-        # We want exclusiveDisks to operate on anything that could be
-        # considered a directly usable disk, ie: fwraid array, mpath, or disk.
-        #
-        # Unfortunately, since so many things are represented as disks by
-        # udev/sysfs, we have to define what is a disk in terms of what is
-        # not a disk.
+        """ Return True if the udev device looks like a disk.
+
+            :param info: udevdb device entry
+            :type info: dict
+            :returns: whether the device is a disk
+            :rtype: bool
+
+            We want exclusiveDisks to operate on anything that could be
+            considered a directly usable disk, ie: fwraid array, mpath, or disk.
+
+            Unfortunately, since so many things are represented as disks by
+            udev/sysfs, we have to define what is a disk in terms of what is
+            not a disk.
+        """
         return (udev_device_is_disk(info) and
                 not (udev_device_is_cdrom(info) or
                      udev_device_is_partition(info) or
@@ -1718,6 +1776,20 @@ class DeviceTree(object):
                 devicelibs.lvm.lvm_cc_addFilterRejectRegexp(pv.name)
 
     def hide(self, device):
+        """ Hide the specified device.
+
+            :param device: the device to hide
+            :type device: :class:`~.devices.StorageDevice`
+
+            If the device is not a leaf device, all devices that depend on it
+            will be hidden leaves-first until the device is a leaf device.
+
+            .. note::
+
+                Hiding a device will cancel any actions scheduled on that device
+                or any device that depends on it.
+
+        """
         if device in self._hidden:
             return
 
@@ -1755,6 +1827,18 @@ class DeviceTree(object):
             self.dasd.removeDASD(device)
 
     def unhide(self, device):
+        """ Restore a device's visibility.
+
+            :param device: the device to restore/unhide
+            :type device: :class:`~.devices.StorageDevice`
+
+            .. note::
+
+                Actions canceled while hiding the device are not rescheduled
+                automatically.
+
+        """
+
         # the hidden list should be in leaves-first order
         for hidden in reversed(self._hidden):
             if hidden == device or hidden.dependsOn(device):
@@ -1850,7 +1934,15 @@ class DeviceTree(object):
         self.backupConfigs(restore=True)
 
     def populate(self, cleanupOnly=False):
-        """ Locate all storage devices. """
+        """ Locate all storage devices.
+
+            Everything should already be active. We just go through and gather
+            details as needed and set up the relations between various devices.
+
+            Devices excluded via disk filtering (or because of disk images) are
+            scanned just the rest, but then they are hidden at the end of this
+            process.
+        """
         self.backupConfigs()
         if cleanupOnly:
             self._cleanup = True
@@ -1964,6 +2056,15 @@ class DeviceTree(object):
                 log.error("setup of %s failed: %s" % (device.name, msg))
 
     def getDeviceBySysfsPath(self, path, incomplete=False, hidden=False):
+        """ Return a list of devices with a matching sysfs path.
+
+            :param path: the sysfs path to match
+            :type path: str
+            :keyword incomplete: include incomplete devices in results
+            :type incomplete: bool
+            :keyword hidden: include hidden devices in results
+            :type hidden: bool
+        """
         if not path:
             return None
 
@@ -1984,6 +2085,15 @@ class DeviceTree(object):
         return found
 
     def getDeviceByUuid(self, uuid, incomplete=False, hidden=False):
+        """ Return a list of devices with a matching UUID.
+
+            :param uuid: the UUID to match
+            :type uuid: str
+            :keyword incomplete: include incomplete devices in results
+            :type incomplete: bool
+            :keyword hidden: include hidden devices in results
+            :type hidden: bool
+        """
         if not uuid:
             return None
 
@@ -2007,6 +2117,15 @@ class DeviceTree(object):
         return found
 
     def getDevicesBySerial(self, serial, incomplete=False, hidden=False):
+        """ Return a list of devices with a matching serial.
+
+            :param serial: the serial to match
+            :type serial: str
+            :keyword incomplete: include incomplete devices in results
+            :type incomplete: bool
+            :keyword hidden: include hidden devices in results
+            :type hidden: bool
+        """
         devices = self._devices[:]
         if hidden:
             devices += self._hidden
@@ -2026,6 +2145,15 @@ class DeviceTree(object):
         return retval
 
     def getDeviceByLabel(self, label, incomplete=False, hidden=False):
+        """ Return a device with a matching filesystem label.
+
+            :param label: the filesystem label to match
+            :type label: str
+            :keyword incomplete: search incomplete devices
+            :type incomplete: bool
+            :keyword hidden: search hidden devices
+            :type hidden: bool
+        """
         if not label:
             return None
 
@@ -2050,6 +2178,15 @@ class DeviceTree(object):
         return found
 
     def getDeviceByName(self, name, incomplete=False, hidden=False):
+        """ Return a device with a matching name.
+
+            :param name: the name to look for
+            :type name: str
+            :keyword incomplete: search incomplete devices
+            :type incomplete: bool
+            :keyword hidden: search hidden devices
+            :type hidden: bool
+        """
         log_method_call(self, name=name)
         if not name:
             log_method_return(self, None)
@@ -2076,6 +2213,15 @@ class DeviceTree(object):
         return found
 
     def getDeviceByPath(self, path, preferLeaves=True, incomplete=False, hidden=False):
+        """ Return a device with a matching path.
+
+            :param path: the path to match
+            :type path: str
+            :keyword incomplete: include incomplete devices in results
+            :type incomplete: bool
+            :keyword hidden: include hidden devices in results
+            :type hidden: bool
+        """
         log_method_call(self, path=path)
         if not path:
             log_method_return(self, None)
@@ -2113,20 +2259,35 @@ class DeviceTree(object):
         return found
 
     def getDevicesByType(self, device_type):
+        """ Return a list of devices with a matching device type.
+
+            :param device_type: the type to match
+            :type device_type: str
+        """
         # TODO: expand this to catch device format types
         return [d for d in self._devices if d.type == device_type]
 
     def getDevicesByInstance(self, device_class):
+        """ Return a list of devices with a matching device class.
+
+            :param path: the device class to match
+            :type path: class
+        """
         return [d for d in self._devices if isinstance(d, device_class)]
 
     def getDeviceByID(self, id_num):
+        """ Return a device with specified device id.
+
+            :param id_num: the id to look for
+            :type id_num: int
+        """
         for device in self._devices:
             if device.id == id_num:
                 return device
 
     @property
     def devices(self):
-        """ List of device instances """
+        """ List of devices currently in the tree """
         devices = []
         for device in self._devices:
             if not getattr(device, "complete", True):
@@ -2153,7 +2314,7 @@ class DeviceTree(object):
 
     @property
     def uuids(self):
-        """ Dict with uuid keys and Device values. """
+        """ Dict with uuid keys and :class:`~.devices.Device` values. """
         uuids = {}
         for dev in self._devices:
             try:
@@ -2200,6 +2361,23 @@ class DeviceTree(object):
         return [c for c in self._devices if device in c.parents]
 
     def resolveDevice(self, devspec, blkidTab=None, cryptTab=None, options=None):
+        """ Return the device matching the provided device specification.
+
+            The spec can be anything from a device name (eg: 'sda3') to a device
+            node path (eg: '/dev/mapper/fedora-root' or '/dev/dm-2') to
+            something like 'UUID=xyz-tuv-qrs' or 'LABEL=rootfs'.
+
+            :param devspec: a string describing a block device
+            :type devspec: str
+            :keyword blkidTab: blkid info
+            :type blkidTab: :class:`~.BlkidTab`
+            :keyword cryptTab: crypto info
+            :type cryptTab: :class:`~.CryptTab`
+            :keyword options: mount options
+            :type options: str
+            :returns: the device
+            :rtype: :class:`~.devices.StorageDevice` or None
+        """
         # find device in the tree
         device = None
         if devspec.startswith("UUID="):
diff --git a/blivet/formats/__init__.py b/blivet/formats/__init__.py
index 67ac996..06905ac 100644
--- a/blivet/formats/__init__.py
+++ b/blivet/formats/__init__.py
@@ -62,26 +62,19 @@ def get_default_filesystem_type():
     raise DeviceFormatError("None of %s is supported by your kernel" % ",".join(default_fstypes))
 
 def getFormat(fmt_type, *args, **kwargs):
-    """ Return a DeviceFormat instance based on fmt_type and args.
+    """ Return an instance of the appropriate DeviceFormat class.
 
-        Given a device format type and a set of constructor arguments,
-        return a DeviceFormat instance.
+        :param fmt_type: The name of the formatting type
+        :type fmt_type: str.
+        :return: the format instance
+        :rtype: :class:`DeviceFormat`
+        :raises: ValueError
 
-        Return None if no suitable format class is found.
+        .. note::
 
-        Arguments:
-
-            fmt_type -- the name of the format type (eg: 'ext3', 'swap')
-
-        Keyword Arguments:
-
-            The keyword arguments may vary according to the format type,
-            but here is the common set:
-
-            device -- path to the device on which the format resides
-            uuid -- the UUID of the (preexisting) formatted device
-            exists -- whether or not the format exists on the device            
-            
+            Any additional arguments will be passed on to the constructor for
+            the format class. See the various :class:`DeviceFormat` subclasses
+            for an exhaustive list of the arguments that can be passed.
     """
     fmt_class = get_device_format_class(fmt_type)
     fmt = None
@@ -105,8 +98,10 @@ def getFormat(fmt_type, *args, **kwargs):
 def collect_device_format_classes():
     """ Pick up all device format classes from this directory.
 
-        Note: Modules must call register_device_format(FormatClass) in
-              order for the format class to be picked up.
+        .. note::
+
+            Modules must call :func:`register_device_format` to make format
+            classes available to :func:`getFormat`.
     """
     dir = os.path.dirname(__file__)
     for module_file in os.listdir(dir):
@@ -122,7 +117,13 @@ def collect_device_format_classes():
                 log.debug(format_exc())
 
 def get_device_format_class(fmt_type):
-    """ Return an appropriate format class based on fmt_type. """
+    """ Return an appropriate format class.
+
+        :param fmt_type: The name of the format type.
+        :type fmt_type: str.
+        :returns: The chosen DeviceFormat class
+        :rtype: class.
+    """
     if not device_formats:
         collect_device_format_classes()
 
@@ -143,7 +144,12 @@ def get_device_format_class(fmt_type):
     return fmt
 
 class DeviceFormat(object):
-    """ Generic device format. """
+    """ Generic device format.
+
+        This represents the absence of recognized formatting. That could mean a
+        device is uninitialized, has had zeros written to it, or contains some
+        valid formatting that this module does not support.
+    """
     _type = None
     _name = _("Unknown")
     _udevTypes = []
@@ -163,14 +169,21 @@ class DeviceFormat(object):
     _ksMountpoint = None
 
     def __init__(self, *args, **kwargs):
-        """ Create a DeviceFormat instance.
-
-            Keyword Arguments:
-
-                device -- path to the underlying device
-                uuid -- this format's UUID
-                exists -- indicates whether this is an existing format
-
+        """
+            :keyword device: The path to the device node.
+            :type device: str
+            :keyword uuid: the formatting's UUID.
+            :type uuid: str
+            :keyword exists: Whether the formatting exists. (default: False)
+            :raises: ValueError
+
+            .. note::
+
+                The 'device' kwarg is required for existing formats. For non-
+                existent formats, it is only necessary that the :attr:`device`
+                attribute be set before the :meth:`create` method runs. Note
+                that you can specify the device at the last moment by specifying
+                it via the 'device' kwarg to the :meth:`create` method.
         """
         self.device = kwargs.get("device")
         self.uuid = kwargs.get("uuid")
@@ -300,6 +313,18 @@ class DeviceFormat(object):
         return self._majorminor
 
     def create(self, *args, **kwargs):
+        """ Write the formatting to the specified block device.
+
+            :keyword device: path to device node
+            :type device: str.
+            :raises: FormatCreateError
+            :returns: None.
+
+            .. :note::
+
+                If a device node path is passed to this method it will overwrite
+                any previously set value of this instance's "device" attribute.
+        """
         log_method_call(self, device=self.device,
                         type=self.type, status=self.status)
         # allow late specification of device path
@@ -311,6 +336,11 @@ class DeviceFormat(object):
             raise FormatCreateError("invalid device specification", self.device)
 
     def destroy(self, *args, **kwargs):
+        """ Remove the formatting from the associated block device.
+
+            :raises: FormatDestroyError
+            :returns: None.
+        """
         log_method_call(self, device=self.device,
                         type=self.type, status=self.status)
         try:
@@ -329,6 +359,18 @@ class DeviceFormat(object):
         self.exists = False
 
     def setup(self, *args, **kwargs):
+        """ Activate the formatting.
+
+            :keyword device: device node path
+            :type device: str.
+            :raises: FormatSetupError.
+            :returns: None.
+
+            .. :note::
+
+                If a device node path is passed to this method it will overwrite
+                any previously set value of this instance's "device" attribute.
+        """
         log_method_call(self, device=self.device,
                         type=self.type, status=self.status)
 
@@ -347,6 +389,7 @@ class DeviceFormat(object):
             raise FormatSetupError("invalid device specification")
 
     def teardown(self, *args, **kwargs):
+        """ Deactivate the formatting. """
         log_method_call(self, device=self.device,
                         type=self.type, status=self.status)
 
diff --git a/blivet/formats/biosboot.py b/blivet/formats/biosboot.py
index c3aef8d..d7a5836 100644
--- a/blivet/formats/biosboot.py
+++ b/blivet/formats/biosboot.py
@@ -38,13 +38,15 @@ class BIOSBoot(DeviceFormat):
     _minSize = 0.5                      # minimum size in MB
 
     def __init__(self, *args, **kwargs):
-        """ Create a BIOSBoot instance.
-
-            Keyword Arguments:
+        """
+            :keyword device: path to the block device node
+            :type device: str
+            :keyword exists: whether the formatting exists
+            :type exists: bool
 
-                device -- path to the underlying device
-                exists -- indicates whether this is an existing format
+            .. note::
 
+                The 'device' kwarg is required for existing formats.
         """
         DeviceFormat.__init__(self, *args, **kwargs)
 
diff --git a/blivet/formats/disklabel.py b/blivet/formats/disklabel.py
index 0650162..948b729 100644
--- a/blivet/formats/disklabel.py
+++ b/blivet/formats/disklabel.py
@@ -48,18 +48,20 @@ class DiskLabel(DeviceFormat):
     _supported = False                 # is supported
 
     def __init__(self, *args, **kwargs):
-        """ Create a DiskLabel instance.
-
-            Keyword Arguments:
-
-                labelType -- type of disklabel to create
-                device -- path to the underlying device
-                exists -- indicates whether this is an existing format
-
+        """
+            :keyword device: full path to the block device node (required)
+            :type device: str
+            :keyword labelType: type of disklabel to create
+            :type labelType: str
+            :keyword exists: whether the formatting exists
+            :type exists: bool
         """
         log_method_call(self, *args, **kwargs)
         DeviceFormat.__init__(self, *args, **kwargs)
 
+        if not self.device:
+            raise ValueError("DiskLabel requires a valid device path")
+
         if not self.exists:
             self._labelType = kwargs.get("labelType", "msdos")
         else:
@@ -234,25 +236,6 @@ class DiskLabel(DeviceFormat):
         """ Device status. """
         return False
 
-    def setup(self, *args, **kwargs):
-        """ Open, or set up, a device. """
-        log_method_call(self, device=self.device,
-                        type=self.type, status=self.status)
-        if not self.exists:
-            raise DeviceFormatError("format has not been created")
-
-        if self.status:
-            return
-
-        DeviceFormat.setup(self, *args, **kwargs)
-
-    def teardown(self, *args, **kwargs):
-        """ Close, or tear down, a device. """
-        log_method_call(self, device=self.device,
-                        type=self.type, status=self.status)
-        if not self.exists:
-            raise DeviceFormatError("format has not been created")
-
     def create(self, *args, **kwargs):
         """ Create the device. """
         log_method_call(self, device=self.device,
@@ -308,15 +291,23 @@ class DiskLabel(DeviceFormat):
         else:
             self.updateOrigPartedDisk()
 
-    def addPartition(self, *args, **kwargs):
-        partition = kwargs.get("partition", None)
-        if not partition:
-            partition = args[0]
+    def addPartition(self, partition, constraint=None):
+        """ Add a partition to the disklabel.
+
+            :param partition: partition from which to get geom, type (required)
+            :type partition: parted.Partition.
+            :keyword constraint: constraint to use
+            :type constraint: parted.Constraint.
+
+            .. note::
+
+                This does not add the :class:`parted.Partition` instance you
+                pass in. The geometry and type are taken from that instance and
+                used to create a new :class:`parted.Partition` to add to the
+                disklabel.
+        """
         geometry = partition.geometry
-        constraint = kwargs.get("constraint", None)
-        if not constraint and len(args) > 1:
-            constraint = args[1]
-        elif not constraint:
+        if not constraint:
             constraint = parted.Constraint(exactGeom=geometry)
 
         new_partition = parted.Partition(disk=self.partedDisk,
@@ -326,6 +317,17 @@ class DiskLabel(DeviceFormat):
                                      constraint=constraint)
 
     def removePartition(self, partition):
+        """ Remove a partition from the disklabel.
+
+            :param partition: the partition to remove
+            :type partition: parted.Partition.
+
+            .. note::
+
+                Unlike :meth:`addPartition`, the actual partition instance
+                passed is what will be removed from the disklabel.
+
+        """
         self.partedDisk.removePartition(partition)
 
     @property
diff --git a/blivet/formats/dmraid.py b/blivet/formats/dmraid.py
index 2bf4567..e7d97b8 100644
--- a/blivet/formats/dmraid.py
+++ b/blivet/formats/dmraid.py
@@ -60,15 +60,13 @@ class DMRaidMember(DeviceFormat):
     _hidden = True                      # hide devices with this formatting?
 
     def __init__(self, *args, **kwargs):
-        """ Create a DeviceFormat instance.
-
-            Keyword Arguments:
-
-                device -- path to the underlying device
-                uuid -- this format's UUID
-                exists -- indicates whether this is an existing format
-
-            On initialization this format is like DeviceFormat
+        """
+                :keyword device: path to the underlying device (required)
+                :type device: str
+                :keyword uuid: this format's UUID
+                :type uuid: str
+                :keyword exists: whether this is an existing format
+                :type exists: bool
 
         """
         log_method_call(self, *args, **kwargs)
